pipeline {
    agent any
    parameters {
        string(name: "APP_NAME", defaultValue:"Api-Investimentos")
    //    string(name: "VM_PATH", defaultValue:"ec2-18-188-227-176.us-east-2.compute.amazonaws.com")
     //   string(name: "VM_USER", defaultValue:"ubuntu")
        string(name: "REGISTRY_URL", defaultValue: "registry-itau.mastertech.com.br")
        string(name: "IMAGE_NAME", defaultValue: "registry-itau.mastertech.com.br/avila_investimentos")
        string(name: "CONTAINER_NAME", defaultValue: "avila_investimentos")

        string(name: "NAMESPACE", defaultValue: "avila")
        string(name: "PATH_DEPLOY", defaultValue: "deployment/avila-investimentos-deployment")

    }

    stages {
        stage("Agora vai") {
            steps {
                echo "uhuuuu"
            }
        }

         stage("Test") {
            steps {
                echo "iniciando testes"
                sh "java -version"
                sh "./mvnw test"
            }
         }

        stage('Build e Publicando Imagem docker') {
            steps {
                echo 'Criando imagem e publicando no Registro.'
                sh "./mvnw package -DskipTests"
                sh "ls target/"
                script {
                    docker.withRegistry("https://${params.REGISTRY_URL}","registry_credential"){
                        def customImage=docker.build("${params.IMAGE_NAME}")
                        customImage.push("${BUILD_NUMBER}")
                        customImage.push("latest")
                    }
                }
            }
        }


//        stage("Deploy na AWS") {
//            when {  branch "master"}
//            steps{
//                echo 'Deployando imagem num container !!'
//                sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker pull ${params.IMAGE_NAME}"
//                sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker stop ${params.CONTAINER_NAME}"
//                sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker run --rm -p 32000:8080 -d --name ${params.CONTAINER_NAME} ${params.IMAGE_NAME}:latest"
//            }
//
//         }

        stage("Deploy na AWS Kubernetes") {
            when { branch "master" }
            steps {
                echo 'Deployando imagem Kubernetes !!'

                sh "kubectl rollout restart -n ${params.NAMESPACE} ${params.PATH_DEPLOY}"
           //     sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker pull ${params.IMAGE_NAME}"
            //    sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker stop ${params.CONTAINER_NAME}"
           //     sh "ssh -o StrictHostKeyChecking=no -T ${params.VM_USER}@${params.VM_PATH} docker run --rm -p 32000:8080 -d --name ${params.CONTAINER_NAME} ${params.IMAGE_NAME}:latest"
            }
        }
            //   stage ("Restart do servico"){
     //       steps{
      //          sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_PATH} sudo systemctl restart investimentos.service"
      //      }
     //   }

        stage ("Testando servico") {
            steps {
                sh "curl -v http://cafezinhonaquebrada.mastertech.com.br/avila-investimentos/investimentos/"
            }
        }
    }
}